/*
WebPageMaker.h
Written by Matthew Fisher
*/

struct WebPageParameters
{
    String SourceDirectory;
    String TargetDirectory;
    String ZipBaseDirectory;
    String SourceToHTMLConverterDirectory;
};

class WebPageMaker
{
public:
    void MakeWebPage(const WebPageParameters &Parameters);

private:
    void MakeZipFiles(const WebPageParameters &Parameters);
    void MakeSinglePage(const WebPageParameters &Parameters, const String &S);
    void SaveZipFile(const WebPageParameters &parameters, const String &filename, const Vector<String> &files);
    void AppendFiles(const String &baseZipDirectory, const String &fileDirectory, const String &filter, Vector<String> &files);

    bool FilenameMatchesFilter(const String &filename, const String &filter);
};
